Index: flashchips.c
===================================================================
--- flashchips.c	(revision 1781)
+++ flashchips.c	(working copy)
@@ -5909,6 +5909,24 @@
 
 	{
 		.vendor		= "Macronix",
+		.name		= "MX23L3254",
+		.bustype	= BUS_SPI,
+		.manufacture_id	= MACRONIX_ID,
+		.model_id	= MACRONIX_MX23L3254,
+		.total_size	= 4096,
+		.page_size	= 256,
+		.tested		= TEST_OK_PR | TEST_BAD_EW,
+		.probe		= probe_spi_rdid,
+		.probe_timing	= TIMING_ZERO,
+		.printlock	= spi_prettyprint_status_register_default_bp1,
+		.unlock		= NULL,
+		.write		= NULL, /* MX23L3254 is a mask ROM, so it is read-only */
+		.read		= spi_chip_read,
+		.voltage	= {3000, 3600},
+	},
+
+	{
+		.vendor		= "Macronix",
 		.name		= "MX25L512(E)/MX25V512(C)",
 		.bustype	= BUS_SPI,
 		.manufacture_id	= MACRONIX_ID,
Index: flashchips.h
===================================================================
--- flashchips.h	(revision 1781)
+++ flashchips.h	(working copy)
@@ -430,6 +430,7 @@
  * and use the same set of IDs.
  */
 #define MACRONIX_ID		0xC2	/* Macronix (MX) */
+#define MACRONIX_MX23L3254	0x0516	/* MX23L3254 mask ROM (4M) */
 #define MACRONIX_MX25L512	0x2010	/* Same as MX25L512E, MX25V512, MX25V512C */
 #define MACRONIX_MX25L1005	0x2011	/* Same as MX25L1005C, MX25L1006E */
 #define MACRONIX_MX25L2005	0x2012	/* Same as MX25L2005C */
